
/******************************************************************************
 * 
 *	Copyright (c) 2004 Novell, Inc.
 *	All rights reserved.
 *
 *	Redistribution and use in source and binary forms, with or without 
 *	modification, are permitted provided that the following conditions are met:
 *
 *	Redistributions of source code must retain the above copyright notice, this 
 *	list of conditions and the following disclaimer. 
 *
 *	Redistributions in binary form must reproduce the above copyright notice, 
 *	this list of conditions and the following disclaimer in the documentation 
 *	and or other materials provided with the distribution.
 *
 *	Neither the name of Novell nor the names of its contributors may be used to 
 *	endorse or promote products derived from this software without specific prior
 *	written permission. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 *	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 *	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 *	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 *	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 *	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 *	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************
*/
 
#include "md5parse.h"


typedef struct digestMD5ctx LDAP_DIGEST_MD5_CONTEXT;

struct digestMD5ctx
{
        DigestChallenge    *pChallenge;
        char               **realms;
        int                state;
        struct ldap        *ld;
};

#define DIGEST_MD5_STATE_STARTED   1
#define DIGEST_MD5_STATE_FINISHED  2
#define LDAP_DIGEST_MD5_FINISH  1
#define LDAP_DIGEST_MD5_ABORT   2
#define LDAP_MALLOC malloc
#define LDAP_FREE free


LDAP_F(int)
ldap_bind_digest_md5_start LDAP_P((
    LDAP                      *ld,
    LDAP_DIGEST_MD5_CONTEXT   **pMD5Context));
                                                                                
LDAP_F(int)
ldap_get_digest_md5_realms LDAP_P((
        LDAP_DIGEST_MD5_CONTEXT         *MD5context,
        char                        ***realms));

LDAP_F( int )
ldap_bind_digest_md5_finish LDAP_P((
        LDAP_DIGEST_MD5_CONTEXT   **pMD5context,
        char                      *authID,
        char                      *password,
	int                       passwordLen,
        int                       realmIndex,
        int                       abortFlag));
                                                                                

